regina::PluggedTorusBundle Class Reference
Standard Triangulations and Subcomplexes

Describes a triangulation of a graph manifold formed by joining a bounded saturated region with a thin I-bundle over the torus, possibly with layerings in between. More...

`#include <subcomplex/pluggedtorusbundle.h>`

Inheritance diagram for regina::PluggedTorusBundle:

## Public Member Functions

| ~PluggedTorusBundle ()
| Destroys this structure and its constituent components. More...
const TxICore & | bundle () const
| Returns an isomorphic copy of the thin I-bundle that forms part of this triangulation. More...
const Isomorphism< 3 > & | bundleIso () const
| Returns an isomorphism describing how the thin I-bundle forms a subcomplex of this triangulation. More...
const SatRegion & | region () const
| Returns the saturated region that forms part of this triangulation. More...
const Matrix2 & | matchingReln () const
| Returns the matrix describing how the two torus boundaries of the saturated region are joined by the thin I-bundle and layerings. More...
Manifold * | manifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | name () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | TeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual AbelianGroup * | homology () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
AbelianGroup * | homologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Static Public Member Functions

static PluggedTorusBundle * | isPluggedTorusBundle (Triangulation< 3 > *tri)
| Determines if the given triangulation is a saturated region joined to a thin I-bundle via optional layerings, as described in the class notes above. More...
static StandardTriangulation * | isStandardTriangulation (Component< 3 > *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static StandardTriangulation * | isStandardTriangulation (Triangulation< 3 > *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Describes a triangulation of a graph manifold formed by joining a bounded saturated region with a thin I-bundle over the torus, possibly with layerings in between.

The thin I-bundle must be untwisted, so that it forms the product `T x I` with two boundary tori. Moreover, it must be isomorphic to some existing instance of the class TxICore.

The saturated region is described by an object of the class SatRegion. This region must have precisely two boundary annuli. These may be two separate torus boundaries (each formed from its own saturated annulus). Alternatively, the saturated region may have a single boundary formed from both saturated annuli, where this boundary is pinched together so that each annulus becomes its own two-sided torus.

Either way, the saturated region effectively has two torus boundaries, each formed from two triangles of the triangulation. These boundaries are then joined to the two torus boundaries of the thin I-bundle, possibly with layerings in between (for more detail on layerings, see the Layering class). This is illustrated in the following diagram, where the small tunnels show where the torus boundaries are joined (possibly via layerings).

       /--------------------\     /-----------------\
       |                     -----                  |
       |                     -----                  |
       |  Saturated region  |     |  Thin I-bundle  |
       |                     -----                  |
       |                     -----                  |
       --------------------/     -----------------/

The effect of the thin I-bundle and the two layerings is essentially to join the two boundaries of the saturated region according to some non-trivial homeomorphism of the torus. This homeomorphism is specified by a 2-by-2 matrix M as follows.

Suppose that f0 and o0 are directed curves on the first boundary torus and f1 and o1 are directed curves on the second boundary torus, where f0 and f1 represent the fibres of the saturated region and o0 and o1 represent the base orbifold (see the page on Notation for Seifert fibred spaces for terminology). Then the torus boundaries of the saturated region are identified by the thin I-bundle and layerings according to the following relation:

        [f1]       [f0]
        [  ] = M * [  ]
        [o1]       [o0]

Note that the routines writeName() and writeTeXName() do not offer enough information to uniquely identify the triangulation, since this essentially requires 2-dimensional assemblings of saturated blocks. For more detail, writeTextLong() may be used instead.

The optional StandardTriangulation routine manifold() is implemented for this class, but homology() is not.

## Constructor & Destructor Documentation

## ~PluggedTorusBundle()

regina::PluggedTorusBundle::~PluggedTorusBundle | ( |  | ) |

Destroys this structure and its constituent components.

As an exception, the thin I-bundle is not destroyed, since it is assumed that this is referenced from elsewhere.

## Member Function Documentation

## bundle()

const TxICore & regina::PluggedTorusBundle::bundle | ( |  | ) | const

inline

Returns an isomorphic copy of the thin I-bundle that forms part of this triangulation.

Like all objects of class TxICore, the thin I-bundle that is returned is an external object with its own separate triangulation of the product `T x I`. For information on how the thin I-bundle is embedded within this triangulation, see the routine bundleIso().

Returns
  the an isomorphic copy of the thin I-bundle within this triangulation.

## bundleIso()

const Isomorphism< 3 > & regina::PluggedTorusBundle::bundleIso | ( |  | ) | const

inline

Returns an isomorphism describing how the thin I-bundle forms a subcomplex of this triangulation.

The thin I-bundle returned by bundle() does not directly refer to tetrahedra within this triangulation. Instead it contains its own isomorphic copy of the thin I-bundle triangulation (as is usual for objects of class TxICore).

The isomorphism returned by this routine is a mapping from the triangulation bundle().core() to this triangulation, showing how the thin I-bundle appears as a subcomplex of this structure.

Returns
  an isomorphism from the thin I-bundle described by bundle() to the tetrahedra of this triangulation.

## detail()

std::string regina::Output< StandardTriangulation , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## homology()

AbelianGroup * regina::StandardTriangulation::homology | ( |  | ) | const

inline virtual inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented in regina::LayeredSolidTorus, regina::TriSolidTorus, regina::LayeredChain, regina::SpiralSolidTorus, regina::LayeredTorusBundle, regina::SnapPeaCensusTri, regina::LayeredLensSpace, regina::SnappedBall, regina::LayeredLoop, regina::TrivialTri, regina::L31Pillow, and regina::LayeredChainPair.

## homologyH1()

AbelianGroup * regina::StandardTriangulation::homologyH1 | ( |  | ) | const

inline inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

## isPluggedTorusBundle()

static PluggedTorusBundle* regina::PluggedTorusBundle::isPluggedTorusBundle | ( | Triangulation< 3 > * | tri | ) |

static

Determines if the given triangulation is a saturated region joined to a thin I-bundle via optional layerings, as described in the class notes above.

Parameters

  tri | the triangulation to examine.

Returns
  a newly created object containing details of the structure that was found, or `null` if the given triangulation is not of the form described by this class.

## isStandardTriangulation() [1/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Component< 3 > * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(Triangulation<3>*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

## isStandardTriangulation() [2/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Triangulation< 3 > * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(Component<3>*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

## manifold()

Manifold* regina::PluggedTorusBundle::manifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::StandardTriangulation.

## matchingReln()

const Matrix2 & regina::PluggedTorusBundle::matchingReln | ( |  | ) | const

inline

Returns the matrix describing how the two torus boundaries of the saturated region are joined by the thin I-bundle and layerings.

See the class notes above for details.

Returns
  the matching relation between the two region boundaries.

## name()

std::string regina::StandardTriangulation::name | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

## region()

const SatRegion & regina::PluggedTorusBundle::region | ( |  | ) | const

inline

Returns the saturated region that forms part of this triangulation.

The region refers directly to tetrahedra within this triangulation (as opposed to the thin I-bundle, which refers to a separate external triangulation).

Returns
  the saturated region.

## str()

std::string regina::Output< StandardTriangulation , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## TeXName()

std::string regina::StandardTriangulation::TeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

## utf8()

std::string regina::Output< StandardTriangulation , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeName()

std::ostream& regina::PluggedTorusBundle::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTeXName()

std::ostream& regina::PluggedTorusBundle::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTextLong()

void regina::PluggedTorusBundle::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes a detailed text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::StandardTriangulation.

## writeTextShort()

void regina::StandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes a short text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

The documentation for this class was generated from the following file:

- subcomplex/pluggedtorusbundle.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).